﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Net;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;
using System.Web.Script.Serialization;

namespace HTTP_JSON_AdapterExamples
{
	class Program
	{
		static string MerchantGUID = "7d099995-e2f9-4a01-bef1-258eb99c1b77";
		static string MerchantPassword = "7R#@Sdr";
		static string eWalletAPIURL = "https://testewallet.com/eWalletWS/ws_JsonAdapter.aspx";		// TEST EWALLET URL
		//static string eWalletAPIURL = "https://www.i-payout.net/eWalletWS/ws_JsonAdapter.aspx";		// PRODUCTION EWALLET URL

		static void Main(string[] args)
		{
			try
			{
				// NOTE: for debugging disable Visual Studio hosting process (Project / Properties / Debug)
				// to avoid exeption in System.Web.Helpers.Json.Decode

				//eWallet_RegisterUser();
				//eWallet_AddCheckoutItems();
				//eWallet_Load();
				//eWallet_CurrencyBalance();

				// use this code to check received hash in notifications
				HashCheck();
			}
			catch
			{
			}
		}

		private static void eWallet_RegisterUser()
		{
			Dictionary<string, object> dic = new Dictionary<string, object>();
			dic.Add("fn", "eWallet_RegisterUser");
			dic.Add("MerchantGUID", MerchantGUID);
			dic.Add("MerchantPassword", MerchantPassword);
			dic.Add("UserName", "json_user_2");
			dic.Add("FirstName", "WSTest");
			dic.Add("LastName", "Test");
			dic.Add("CompanyName", "");
			dic.Add("Address1", "2500 E Hallandale Beach Blvd");
			dic.Add("Address2", "Suite 800 & 900");
			dic.Add("City", "Hallandale Beach");
			dic.Add("State", "FL");
			dic.Add("ZipCode", "33009");
			dic.Add("Country2xFormat", "US");
			dic.Add("PhoneNumber", "954-123-4567");
			dic.Add("CellPhoneNumber", "");
			dic.Add("EmailAddress", "user@aol.com");
			dic.Add("SSN", "123-45-6789");
			dic.Add("CompanyTaxID", "");
			dic.Add("GovernmentID", "");
			dic.Add("MilitaryID", "");
			dic.Add("PassportNumber", "");
			dic.Add("DriversLicense", "");
			dic.Add("DateOfBirth", "9/18/1945");
			dic.Add("WebsitePassword", "passw0rd");
			dic.Add("DefaultCurrency", "USD");

			string json = new JavaScriptSerializer().Serialize(dic);

			WebClient wc = new WebClient();
			String ret = wc.UploadString(eWalletAPIURL, json);

			dynamic res = System.Web.Helpers.Json.Decode(ret);
			int m_Code = res.response.m_Code; // if success it should be NO_ERROR (0)
			String m_Text = res.response.m_Text;// if error, it will contain error description
		}

		private static void eWallet_AddCheckoutItems()
		{
			Dictionary<string, object> dic = new Dictionary<string, object>();
			dic.Add("fn", "eWallet_AddCheckoutItems");
			dic.Add("MerchantGUID", MerchantGUID);
			dic.Add("MerchantPassword", MerchantPassword);
			dic.Add("UserName", "json_user_1");

			List<Dictionary<string, object>> listItems = new List<Dictionary<string, object>>();
			{
				// regular payment
				Dictionary<string, object> itm = new Dictionary<string, object>();
				itm.Add("Amount", 10.79M);
				itm.Add("CurrencyCode", "USD");
				itm.Add("ItemDescription", "Initial Payment for \"Product 1\"");
				itm.Add("MerchantReferenceID", "json_MyDatabaseTransactionRef_1");
				itm.Add("UserReturnURL", "http://www.mysite.com/Thankyou.aspx"); // only usefull for instant payments like from eWallet or credit card");
				itm.Add("MustComplete", "true");
				listItems.Add(itm);
			}

			{
				Dictionary<string, object> itm = new Dictionary<string, object>();
				// monthly subscription payment with initial payment
				itm.Add("Amount", 59.95M);		// initial payment amount
				itm.Add("CurrencyCode", "USD");
				itm.Add("ItemDescription", "eBook purchase");
				itm.Add("MerchantReferenceID", "json_MyDatabaseTransactionRef_12");
				itm.Add("UserReturnURL", "");
				itm.Add("MustComplete", "false");
				itm.Add("IsSubscription", "true");
				itm.Add("SubscriptionAmount", 19.95M);		// monthly subscription amount
				itm.Add("SubscriptionDaysToStart", "0");
				listItems.Add(itm);
			}

			dic.Add("arrItems", listItems.ToArray());

			string json = new JavaScriptSerializer().Serialize(dic);

			WebClient wc = new WebClient();
			String ret = wc.UploadString(eWalletAPIURL, json);

			dynamic res = System.Web.Helpers.Json.Decode(ret);
			int m_Code = res.response.m_Code; // if success it should be NO_ERROR (0)
			String m_Text = res.response.m_Text;// if error, it will contain error description

			//int countItemsResponse = res.arrItemsResponse.Length;// should be a count of elements in arrItems
			foreach(dynamic itm in res.arrItemsResponse)
			{
				int itm_Code = itm.m_Code; // if success it should be NO_ERROR(0)/PROCESSING/PENDING (0)
				String itm_Text = itm.m_Text;// if error, it will contain error description
			}
		}

		private static void eWallet_Load()
		{
			Dictionary<string, object> dic = new Dictionary<string, object>();
			dic.Add("fn", "eWallet_Load");
			dic.Add("MerchantGUID", MerchantGUID);
			dic.Add("MerchantPassword", MerchantPassword);
			dic.Add("PartnerBatchID", "c#_json_my_batch_id_1");
			dic.Add("PoolID", "");
			dic.Add("CurrencyCode", "USD");

			List<Dictionary<string, object>> listAccounts = new List<Dictionary<string, object>>();
			{
				Dictionary<string, object> acc = new Dictionary<string, object>();
				acc.Add("UserName", "IP001");
				acc.Add("Amount", 100.00M);
				acc.Add("Comments", "commissions \"for\n pay period 1");
				acc.Add("MerchantReferenceID", "c#_json_REFID0001");
				listAccounts.Add(acc);
			}

			{
				Dictionary<string, object> acc = new Dictionary<string, object>();
				acc.Add("UserName", "IP005");
				acc.Add("Amount", 200.00M);
				acc.Add("Comments", "commissions \"for\n pay period 2");
				acc.Add("MerchantReferenceID", "c#_json_REFID0002");
				listAccounts.Add(acc);
			}

			dic.Add("arrAccounts", listAccounts.ToArray());

			string json = new JavaScriptSerializer().Serialize(dic);

			WebClient wc = new WebClient();
			String ret = wc.UploadString(eWalletAPIURL, json);

			dynamic res = System.Web.Helpers.Json.Decode(ret);
			int m_Code = res.response.m_Code; // if success it should be NO_ERROR (0)
			String m_Text = res.response.m_Text;// if error, it will contain error description
		}

		private static void eWallet_CurrencyBalance()
		{
			Dictionary<string, object> dic = new Dictionary<string, object>();
			dic.Add("fn", "eWallet_GetCurrencyBalance");
			dic.Add("MerchantGUID", MerchantGUID);
			dic.Add("MerchantPassword", MerchantPassword);
			dic.Add("UserName", "IP001");
			dic.Add("CurrencyCode", "USD");

			string json = new JavaScriptSerializer().Serialize(dic);

			WebClient wc = new WebClient();
			String ret = wc.UploadString(eWalletAPIURL, json);

			dynamic res = System.Web.Helpers.Json.Decode(ret);
			int m_Code = res.response.m_Code; // if success it should be NO_ERROR (0)
			String m_Text = res.response.m_Text;// if error, it will contain error description
			Decimal Balance = res.Balance;
		}

		private static void HashCheck()
		{
			String MerchantGUID = "6d099995-a2f9-4a01-bef1-258eb99c1a77";
			String MerchantPassword = "psd123";
			
			// received parameters from notification
			String trnx_id = "54321";
			String log_id = "8790";
			String hash = "F225DA02326628D9444468AB4868A7386D43C912";

			// compute our own hash
			String s = trnx_id + log_id + MerchantGUID + MerchantPassword;
			String mysha = SHA1(s);

			// compare hashes
			if(mysha == hash)
			{
				// process payment
				// ...

				//Page.Visible = false;
				//Response.Clear();
				//Response.Write("OK");// always return OK to confirm the notification was processed 
			}
			else
			{
				// invalid hash
				// do not trust this notification, just exit
			}
		}

		public static String SHA1(String input)
		{
			System.Security.Cryptography.SHA1Managed sec = new System.Security.Cryptography.SHA1Managed();
			byte[] bs = System.Text.Encoding.UTF8.GetBytes(input);
			bs = sec.ComputeHash(bs);
			System.Text.StringBuilder s = new System.Text.StringBuilder();
			foreach(byte b in bs)
			{
				s.Append(b.ToString("X2"));
			}
			return s.ToString();
		}
	}
}
